<template>
  <div>
    <div class="dashboard__header">
      <h1 class="dashboard__title">مدیریت کاربران</h1>
      <div class="dashboard__actions">
        <ResponsiveComponent>
          <Button type="outlined" color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/users/create')">
            <template #icon>
              <AddIcon />
            </template>
            کاربر جدید
          </Button>
          <template #collapsed>
            <Button type="text" round color='dark' light size="sm" @click.native="$router.push('/dashboard/admin/users/create')">
              <template #icon>
                <AddIcon />
              </template>
            </Button>
          </template>
        </ResponsiveComponent>
        <Button type="text" color='dark' light round size="sm" @click.native="$router.push('/dashboard')">
          <template #icon>
            <BackIcon />
          </template>
        </Button>
      </div>
    </div>
    <div class="dashboard__body">
      <DashboardNavigation class="dashboard__nav" active="users" />
      <div class="dashboard__content">
        <Card title="کاربران">
          <template #actions v-if="count">
            <p class="count">{{ count }} عدد</p>
          </template>
          <ManagingItemRow 
            v-for="user in users" 
            :key="user.id" 
            :item="formatUser(user)" 
            :second-column="formatUser(user).role"
            baseEditPath="/dashboard/admin/users" 
            :disabled="user.id === $store.getters['auth/getUser'].id"
            :special="user.id === $store.getters['auth/getUser'].id"
            @delete="onDelete" />
        </Card>
        <Paginate class="paginate" :pages="totalPages" />
      </div>
    </div>
  </div>
</template>

<script>
import DashboardNavigation from "@/components/layout/DashboardNavigation";
import BackIcon from "@/assets/svgs/back.svg";
import Button from "@/components/base/Button";
import AddIcon from "@/assets/svgs/add.svg";
import Card from "@/components/base/Card";
import ManagingItemRow from "@/components/dashboard/ManagingItemRow";
import ResponsiveComponent from "@/components/base/ResponsiveComponent";
import Paginate from "@/components/base/Paginate";

export default {
  components: {
    DashboardNavigation,
    BackIcon,
    Card,
    ManagingItemRow,
    AddIcon,
    Button,
    ResponsiveComponent,
    Paginate
  },
  head() {
    return {
      title: "مدیریت کاربران"
    }
  },
  key(route) {
    return route.fullPath
  },
  layout: "dashboard",
  async asyncData(context) {
    let users = [];
    let count = 0;
    let currentPage, totalPages;
    const token = context.store.getters['auth/getToken'];
    const page = context.route.query.page || 1;
    await context.store.dispatch('auth/fetchUsers', {token, page}).then(response => {
      users = response.data.data;
      count = response.data.meta.total;
      currentPage = response.data.meta.current_page;
      totalPages = response.data.meta.last_page;
    }).catch(error => {
      console.log(error);
    });
    return {
      users,
      count,
      currentPage,
      totalPages
    }
  },
  methods: {
    onDelete(id) {
      this.$store.dispatch('auth/deleteUser', {
        token: this.$store.getters['auth/getToken'],
        id: id
      }).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: "کاربر انتخاب شده با موفقیت حذف شد.",
            light: true,
            type: "success",
            timeout: 3000
          });
          this.users = this.users.filter(cur => cur.id !== id);
          this.count--;
        }
      }).catch(error => {
        if (error.response.status === 404) {
          this.$store.dispatch('notifications/push', {
            message: "کاربر انتخاب شده برای حذف یافت نشد.",
            type: "error",
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: "خطا در اتصال به سرور! لطفا دقایقی دیگر دوباره امتحان کنید.",
            type: "error",
            timeout: 3500
          });
        }
      });
    },
    formatUser(user) {
      return {
        title: user.username,
        id: user.id,
        role: user.role === "admin" ? "مدیر" : "کاربر عادی"
      }
    },
    fetchUsers() {
      const token = this.$store.getters['auth/getToken'];
      const page = this.$route.query.page;
      this.$store.dispatch('auth/fetchUsers', {token, page}).then(response => {
        this.users = response.data.data;
        this.count = response.data.meta.total;
        this.currentPage = response.data.meta.current_page;
        this.totalPages = response.data.meta.last_page;
      }).catch(e => {
        console.log(e);
      });
    }
  },
  created() {
    const displaying = Number(this.$route.query.page) || 1;
    if (this.currentPage !== displaying) {
      this.fetchUsers();
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.count
  opacity .6
  color $grey 

.paginate
  width max-content
  margin $lg auto
</style>